(***************************************************************************
 *
 * Fusion Tree Interface
 *
 * Author: Gerald Baumgartner
 * Date:   17 September 2001
 * Date:   9 April 2010
 *
 ***************************************************************************)

signature FUSION_TREE =
  sig
    eqtype iSetSeq
    eqtype expTree
    eqtype solTree

    datatype fusionTree =
	     Leaf   of iSetSeq * iSetSeq *
		       (IntInf.int * IntInf.int * IntInf.int) *
		       expTree
	   | Unary  of iSetSeq * iSetSeq *
		       (IntInf.int * IntInf.int * IntInf.int) *
		       expTree * fusionTree
	   | Binary of iSetSeq * iSetSeq *
		       (IntInf.int * IntInf.int * IntInf.int) *
		       expTree * fusionTree * fusionTree

    val buildFusionTree : solTree -> fusionTree
    val expTreeToFusionTree : expTree -> fusionTree
    val buildUnfusedFusionTree : expTree -> fusionTree
    val toString : fusionTree -> string
  end
