(***************************************************************************
 *
 * Symbol Table Interface
 *
 * Author: Gerald Baumgartner
 * Date:   27 October 2001
 *
 ***************************************************************************)

signature SYM_TAB =
  sig
    datatype elem = Int of int
		  | Array of int list
		  | Fun of int list
		  | Temp of int list
		  | Result of int list
		  | ResultDecl of string list
		  | Writer of string list

    val clear : unit -> unit
    val deleteTemps : unit -> unit

    val insert : string * elem -> unit
    val lookup : string -> elem option

    val getArrays : unit -> (string * int list) list
    val getFuns : unit -> (string * int list) list
    val getTemps : unit -> (string * int list) list
    val getResult : unit -> (string * int list) option
    val getResultDecl : unit -> (string * string list) option
    val getWriters : unit -> (string * string list) list

    val getRange : string -> int
    val getRanges : string list -> int list

    val mangleNames : bool option -> bool
  end
